//
//  PrivateConversationsViewController.swift
//  VKExt
//
//  Created programmist_NA on 07.06.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import MaterialComponents
import RealmSwift
import PanModal

class PrivateConversationsViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, PrivateConversationsViewProtocol, PanModalPresentable {
    var height: CGFloat {
        get {
            return self.getHeight()
        }
    }
    
	var presenter: PrivateConversationsPresenterProtocol?
    var conversations = try! Realm().objects(Conversation.self).sorted(byKeyPath: "dateInteger", ascending: false).filter("isPrivateConversation = %@", true)
    var token: NotificationToken?
    lazy var realm = try! Realm()
    var searchController: VKSearchBar = VKSearchBar(frame: CGRect(origin: .zero, size: CGSize(width: Screen.bounds.width, height: 52)))
    var dialogTransitionController: MDCDialogTransitionController!
    var dialogViewController: MDCAlertController!
    
    var panScrollable: UIScrollView? {
        return mainTable
    }
    
    var panModalBackgroundColor: UIColor {
        return UIColor.black.withAlphaComponent(0.35)
    }
    
    var shortFormHeight: PanModalHeight {
        return getHeight() < screenHeight / 2 ? .contentHeight(getHeight()) : .contentHeight(screenHeight / 2)
    }
    
    var longFormHeight: PanModalHeight {
        return .contentHeight(getHeight())
    }
    
    var showDragIndicator: Bool {
        return false
    }
    
    var anchorModalToLongForm: Bool {
        return true
    }
    
    var shouldRoundTopCorners: Bool {
        return true
    }
    
    var cornerRadius: CGFloat {
        return 14
    }
    
    var springDamping: CGFloat {
        return 1
    }
    
    var transitionDuration: Double {
        return 0.45
    }
    
    var transitionAnimationOptions: UIView.AnimationOptions {
        return [.curveEaseOut, .allowUserInteraction, .beginFromCurrentState, .preferredFramesPerSecond60]
    }
    
    deinit{
        print("Conversations deinited")
        token?.invalidate()
        NotificationCenter.default.removeObserver(self)
    }
    
//    override var popupHeight: CGFloat { return height }
//
//    override var popupTopCornerRadius: CGFloat { return CGFloat(18) }
//
//    override var popupPresentDuration: Double { return 0.15 }
//
//    override var popupDismissDuration: Double { return 0.15 }
//
//    override var popupShouldDismissInteractivelty: Bool { return true }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.view.backgroundColor = .adaptableWhite
        prepareTable()
        setupTable()
        initialError()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
        setupToolbar(title: "Скрытые переписки", subtitle: "", leftViews: nil, rightViews: nil)
        PrivateConversationsRouter.createModule(self)
        presenter?.start()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        token = conversations.observe { [weak mainTable, weak self] changes in
            guard let tableView = mainTable else { return }
            guard let self = self else { return }
            
            switch changes {
            case .initial:
                tableView.reloadData()
            case .update(_, let deletions, let insertions, let updates):
                tableView.applyChanges(with: deletions, with: insertions, with: updates, at: 0)
            case .error: break
            }
            if self.conversations.isEmpty {
                self.showError(message: "Нет скрытых переписок", image: UIImage(named: "message_read_outline_56"))
                NotificationCenter.default.post(name: NSNotification.Name("noPrivateConversations"), object: nil)
            }
        }
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        token?.invalidate()
        NotificationCenter.default.removeObserver(self)
    }
    
    func initialDialog(title: String, message: String) {
        dialogTransitionController = MDCDialogTransitionController()
        dialogViewController = MDCAlertController(title: title, message: message)
        dialogViewController.titleFont = GoogleSansFont.medium(with: 18)
        dialogViewController.messageFont = GoogleSansFont.regular(with: 16)
        dialogViewController.backgroundColor = .adaptableWhite
        dialogViewController.titleColor = .adaptableBlack
        dialogViewController.messageColor = UIColor.adaptableBlack.withAlphaComponent(0.5)
        let confrim = MDCAlertAction(title: "Удалить") { [weak self] (action) in
            guard let self = self else { return }
            self.dialogViewController.dismiss(animated: true, completion: { [weak self] in
                guard let self = self else { return }
                self.showStatusError(message: "Диалог удален", .success)
            })
        }
        let cancel = MDCAlertAction(title: "Отменa") { [weak self] (action) in
            guard let self = self else { return }
            self.dialogViewController.dismiss(animated: true, completion: nil)
        }
        
        dialogViewController.addAction(cancel)
        dialogViewController.addAction(confrim)
        dialogViewController.cornerRadius = 18
        
        dialogViewController.button(for: confrim)?.setTitleFont(GoogleSansFont.regular(with: 10), for: .normal)
        dialogViewController.button(for: cancel)?.setTitleFont(GoogleSansFont.regular(with: 10), for: .normal)
        dialogViewController.button(for: confrim)?.setTitleColor(.extendedRed, for: .normal)
        dialogViewController.button(for: cancel)?.setTitleColor(.adaptableBlack, for: .normal)
        
        present(dialogViewController, animated: true, completion: nil)
    }
    
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
    }
    
    
    func setupTable() {
        if conversations.isEmpty {
            mainTable.isHidden = true
        }
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        mainTable.register(UINib(nibName: "MessageViewCell", bundle: nil), forCellReuseIdentifier: "MessageViewCell")
        mainTable.tableHeaderView = searchController
        let longPressGestureRecognizer = UILongPressGestureRecognizer(target: self, action: #selector(handleLongPress(_:)))
        longPressGestureRecognizer.minimumPressDuration = 0.25
        mainTable.addGestureRecognizer(longPressGestureRecognizer)
        searchController.setup(placeholder: "Поиск по скрытым перепискам")
        refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
    }
    
    func initialFooter() {
        
    }
    
    func finish() {
        refreshControl.endRefreshing()
        if conversations.isEmpty {
            showError(message: "Нет скрытых переписок", image: UIImage(named: "message_read_outline_56"))
        } else {
            hideError()
            mainTable.reloadData()
        }
    }
    
    func getHeight() -> CGFloat {
        let objectsCount = conversations.count.cgFloatValue
        let height = objectsCount > 0 ? (72 * (objectsCount + 1)) + GlobalConstants.toolbarHeight : Screen.bounds.height / 2
        let screen90Height = getPercentage(from: UIScreen.main.bounds.height.doubleValue, with: 90.0).cgFloatValue
        return height > screen90Height ? screen90Height : height
    }
    
    @objc func refreshTable(_ sender: Any?) {
        self.presenter?.start()
    }
    
    @objc func handleLongPress(_ gestureRecognizer: UILongPressGestureRecognizer?) {
        guard let point = gestureRecognizer?.location(in: self.mainTable) else { return }
        let indexPath = self.mainTable.indexPathForRow(at: point)
        if indexPath == nil {
            print("Long press on table view, not row.")
        } else if gestureRecognizer?.state == .began {
            let messagesCount = conversations[indexPath!.row].unreadCount
            let message = messagesCount == 0 ? "Нет новых сообщений" : "\(conversations[indexPath!.row].unreadCount) \(getStringByDeclension(number: conversations[indexPath!.row].unreadCount, arrayWords: Localization.instance.newMessagesCount))"
            self.initialActionSheet(title: conversations[indexPath!.row].interlocutorName, message: message, actions: self.getActions(at: conversations[indexPath!.row], from: indexPath!))
        }
    }
}
extension PrivateConversationsViewController: UITableViewDelegate, UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return conversations.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "MessageViewCell", for: indexPath) as! MessageViewCell
        cell.alternativeSetup(conversation: conversations[indexPath.row])
        cell.selectionStyle = .none
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 72
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        tableView.deselectRow(at: indexPath, animated: false)
        //        guard let presenter = presenter else { return }
        //        presenter.onTapConversation(at: indexPath)
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
}
extension PrivateConversationsViewController {
    func getActions(at conversation: Conversation, from indexPath: IndexPath) -> [MDCActionSheetAction] {
        let snooze = MDCActionSheetAction(title: "Отключить уведомления", image: UIImage(named: "notification_disable_outline_28"), handler: { action in
        })
        let readConversation = MDCActionSheetAction(title: "Прочитать сообщения", image: UIImage(named: "view_outline_28"), handler: { action in
            //presenter.onTapReadConversation(at: indexPath)
        })
        let performProfile = MDCActionSheetAction(title: "Перейти в профиль", image: UIImage(named: "user_outgoing_outline_28"), handler: { action in
            
        })
        let enableAggressiveTyping = MDCActionSheetAction(title: "Агрессивный тайпинг", image: UIImage(named: "list_add_outline_28"), handler: { action in
            ConversationService.instance.getHiddenKey(keys: ["private_conversation_from\(conversation.peerId)"]) { (values) in
                print(values)
            }
        })
        let disableAggressiveTyping = MDCActionSheetAction(title: "Отключить агрессивный тайпинг", image: UIImage(named: "list_add_outline_28"), handler: { action in
            
        })
        let showConversation = MDCActionSheetAction(title: "Показать переписку", image: UIImage(named: "privacy_outline_28"), handler: { action in
            let realm = try! Realm()
            UserDefaults.standard.set(false, forKey: "private_conversation_from\(conversation.peerId)")
            ConversationService.instance.setHiddenKey(key: "private_conversation_from\(conversation.peerId)", value: "false")
            realm.beginWrite()
            conversation.isPrivateConversation = false
            try! realm.commitWrite()
        })
        let removeConversation = MDCActionSheetAction(title: "Удалить переписку", image: UIImage(named: "delete_outline_28"), handler: { action in
            self.initialDialog(title: "Удаление переписки", message: "Вы действительно хотите удалить диалог?")
        })
        removeConversation.titleColor = .extendedRed
        removeConversation.tintColor = .extendedRed
        return [(conversation.unreadCount > 0 ? readConversation : snooze), performProfile, conversation.isAggressiveTypingActive ? disableAggressiveTyping : enableAggressiveTyping, showConversation, removeConversation]
    }
}
